(function(window) {
	"use strict";
	var scraper = window.scraper;
	var self = scraper.worker = {};

	var START_URL = "https://www.americanexpress.com/de/";
	var LOGOUT_URL = "https://global.americanexpress.com/myca/logon/us/action/logoff";

	var PERIODS_URL = "https://global.americanexpress.com/api/servicing/v1/financials/statement_periods";
	var UMSAETZE_URL = "https://global.americanexpress.com/api/servicing/v1/financials/transactions";
	var SALDO_URL = "https://global.americanexpress.com/api/servicing/v1/financials/balances?extended_details=deferred%252Cearly_pay%252Cpay_over_time";
	var kontenMap = {};

	self.bpdVersion = 1;
	self.updVersion = 1;

	function parseInitialState(obj, stack, kontenMap2) {
		if (Array.isArray(obj)) {
			if (stack.join(":") === ":core:resources:products::productsOrder") {
				obj.forEach(function(k) {
					kontenMap2[k] = {accountToken: k, waehrung: "EUR"};
				});
			}
			var stack2 = stack.concat([""]);
			obj.forEach(function(o) {
				parseInitialState(o, stack2, kontenMap2);
			});
			stack[stack.length-1] = "";
		} else {
			var join = stack.join(":");
			var m = join.match(/:core:resources:products::productsList:(\w+):(?:(account:display_account_number)|profile:embossed_name)/);
			stack[stack.length-1] = typeof obj === "string" && obj.length && obj.charAt(0)==="^" ? "" : obj;
			if (!m) return;
			println("1: " + m[1] + " 2: " + m[2] + " o: " + obj);
			var key = m[1];
			var isAccountNumber = !!m[2];
			if (isAccountNumber) {
				var s = obj;
				while (s.length < 15-2) s = "*" + s;
				kontenMap2[key].kontoNr = "37" + s;
				kontenMap2[key].bezeichnung = "American Express";
			} else {
				kontenMap2[key].kontoinhaber = obj;
			}
		}
	}

	self.login = function() {
		function sicherheitsabfrage() {
			var queries = [
				"Bitte geben Sie Ihre 4-stellige Kartenprüfnummer an, die sich auf der Vorderseite Ihrer Karte befindet",
				"Geburtstag des Vaters (TTMM)",
				"Ein Datum, an das Sie sich auf jeden Fall erinnern",
				"Bitte geben Sie den temporären Sicherheitscode ein",
				{
					text: "temporärer Sicherheitscode wurde",
					re: />\s+(Ein temporärer Sicherheitscode wurde an Ihre E-Mail-Adresse unter[^>]+)/,
				},
			].map(function(q) {
				return typeof q !== "string" ? q : {text: q};
			});

			function formsPredicate(a) {
				return a.id==="onl-login" || a.id==="reAuthOptions" || a.id==="passwordOptions";
			}

			function getOverrides(response) {
				println("getOverrides started");
				var forms = scraper.findForms("Sicherheitsabfrage", formsPredicate, {});
				println("getOverrides x1");
				scraper.assertTrue("Sicherheitsabfrage-forms.length" + forms.length, forms.length ===1);
				println("getOverrides x2");
				var names = ["answer", "DATEMM", "authPwd", "PswdOption"].filter(function(s) {return Object.keys(forms[0].map).indexOf(s) > -1});
				println("getOverrides x3", names);
				scraper.assertTrue("Sicherheitsabfrage-names", names.length);
				println("getOverrides x4");
				var overrides = {};
				overrides[names[0]] = response;
				println("getOverrides done");
				return overrides;
			}

			function getQueryInput(text) {
				var m;
				for (var i=0; i<queries.length; ++i) {
					var q = queries[i];
					if (text.indexOf(q.text) === -1) continue;
					if (!q.re) return {challenge: q.text, type: q.type}
					m = text.match(q.re);
					if (m) return {challenge: m[1], type: q.type}
				}
				var collected = [];
				m = text.match(/(Temporären Sicherheitscode zur einmaligen Verwendung senden[^<]+)/);
				if (m) collected.push("REAUTH_KEY=" + m[1].replace(" zur einmaligen Verwendung ", " "));
				m = text.match(/(Ich habe bereits einen temporären Sicherheitscode)/);
				if (m) collected.push("EXIST_REAUTH_KEY=" +  m[1]);
				m = text.match(/(Online authentifizieren)/);
				if (m) collected.push("ONL=" + m[1]);
				if (!collected.length) return null;
				return {challenge: "Bitte wählen Sie eine Option\n" + collected.join("\n"), type: scraper.queryType.SELECT};
			}

			while (true) {
				var text = scraper.getText()
				if (text.match(/Ihr Kennwort ist fehlerhaft/)) scraper.hirmsThrowPassword();
				var m = text.match(/Leider ist ein Login zum jetzigen Zeitpunkt nicht möglich./);
				if (m) scraper.hirmsThrow("Serverfehler: " + m[0]);

				println("sicherheitsabfrage before getQueryInput");
				var queryInput = getQueryInput(text);
				if (!queryInput) break;
				println("sicherheitsabfrage after getQueryInput");
				var response = scraper.query(queryInput.challenge, queryInput.type);
				if (!response) scraper.hirmsThrow("Sicherheitsabfrage abgebrochen");
				var overrides = getOverrides(response);
				scraper.sendForm("Sicherheitsabfrage", formsPredicate, overrides);
			}
		}

		var found;
		function isFirstLoginForm(a) {
			if (found) return false;
			found = a.name === "form-login" || a.name === "lilo_formLogon"
			return found;
		}

		scraper.httpGet("start", START_URL);
		scraper.sendForm("form-login", isFirstLoginForm, {UserID: scraper.data.kennung, Password: scraper.data.pin});

		println("before sicherheitsabfrage");
		sicherheitsabfrage();
		println("after sicherheitsabfrage");

		scraper.findSimple("title", /<title data-react-helmet="true">American Express - Übersicht</);
		var initialStateString = scraper.findSimple("initialStateString", /\s+window\.__INITIAL_STATE__ = (".*");/);
		var initialStateJson = JSON.parse(initialStateString);
		var initialStateObject = JSON.parse(initialStateJson);

		var kontenMap2 = {};
		parseInitialState(initialStateObject, [""], kontenMap2);
		println("kontenMap2", JSON.stringify(kontenMap2, null, 4));
		Object.values(kontenMap2).forEach(function(e) {
			if (e.kontoNr) kontenMap[e.kontoNr] = e;
		});
		println("kontenMap", JSON.stringify(kontenMap, null, 4));
	};

	self.logout = function() {
		scraper.httpPost("logout", LOGOUT_URL, {request_type: "logoff", Face: "de_DE"});
	};

	self.kontoliste = function() {
		return Object.values(kontenMap);
	};

	self.umsaetze = function() {
		var kontoNr = scraper.data.kontoNr;
		var accountToken = kontenMap[kontoNr] && kontenMap[kontoNr].accountToken;
		scraper.assertTrue("knowsKontoNr-" + kontoNr, accountToken);

		var endSaldo = (function() {
			scraper.httpGet("endSaldo", SALDO_URL, {account_token: accountToken});
			var arr = JSON.parse(scraper.getText());
			scraper.assertTrue("arr.length", arr.length==1);
			var obj = arr[0];
			return {
				waehrung: "EUR",
				betrag: -obj.statement_balance_amount,
				datum: scraper.reformatDate(new Date()),
			};
		})();

		var umsaetze = [];

		function fetchUmsaetze(gebucht, statementEndDate) {
			for (var offset=0; ; ) {
				var suffix = "?limit=1000&offset=" + offset +
					(statementEndDate ? "&statement_end_date=" + statementEndDate : "") +
					"&status=" + (gebucht ? "posted" : "pending");
				scraper.httpGet("fetchUmsaetze-" + suffix, UMSAETZE_URL + suffix, {account_token: accountToken});
				var obj = JSON.parse(scraper.getText());
				println("umsaetze" + suffix, JSON.stringify(obj, null, 4));
				var valuta;
				obj.transactions.forEach(function(t) {
					umsaetze.push({
						gebucht: gebucht,
						abgerechnet: true,
						valuta: scraper.reformatDate(t.charge_date),
						datum: scraper.reformatDate(t.post_date || t.charge_date),
						zweck: t.description,
						betrag: -t.amount,
						waehrung: "EUR",
					});
				});
				if (obj.transactions.length < 1000) break;
				offset += obj.transactions.length;
			}
		}

		scraper.httpGet("statementPeriods-", PERIODS_URL, {account_token: accountToken});
		var statementPeriods = JSON.parse(scraper.getText());
		var limit = scraper.data.von ? scraper.reformatDate(scraper.data.von) : "";
		for (var i=statementPeriods.length; i-->0; ) {
			var statementEndDate = statementPeriods[i].statement_end_date;
			println("statementEndDate", scraper.reformatDate(statementEndDate));
			fetchUmsaetze(true, statementEndDate);
			if (scraper.reformatDate(statementEndDate) < limit) continue;
		}
		fetchUmsaetze(false);

		return {
			umsaetze: umsaetze,
			endSaldo: endSaldo,
		};
	};
})(window);
