(function(window) {
	"use strict";
	var scraper = window.scraper;
	var self = scraper.worker = {};

	var BASE_URL = "https://api.tech26.de/";
	var headers = {Authorization: "Basic bXktdHJ1c3RlZC13ZHBDbGllbnQ6c2VjcmV0"};
	var account;

	self.bpdVersion = 2;
	self.updVersion = 1;

	scraper.settings.speicherzeitraum = 100 * 365;
	scraper.settings.overlapDays = 3;

	self.login = function() {
		var data = {username: scraper.data.kennung, password: scraper.data.pin, grant_type: "password"};
		scraper.httpPost("start", BASE_URL + "oauth/token", data, headers);
		var obj = JSON.parse(scraper.getText());
		// {"access_token":"e5685958-06af-44fe-aeba-ccf1c2426e0b","token_type":"bearer","refresh_token":"9fc5c7e4-df6f-48b7-baae-93011aa7dd9c","expires_in":1119,"scope":"read write trust"}
		var t = obj.access_token;
		scraper.assertTrue("access_token", t);
		headers = {Authorization: "Bearer " + t};

		scraper.httpGet("account", BASE_URL + "api/accounts", headers);
		account = JSON.parse(scraper.getText());
	};

	self.logout = function() {
		headers = null;
	};

	self.kontoliste = function() {
		scraper.httpGet("me", BASE_URL + "api/me", headers);
		var me = JSON.parse(scraper.getText());
		var kontoinhaber = me.firstName + " " + me.lastName;
		return [{
			kontoNr: account.iban.substring(12),
			waehrung: "EUR",
			bezeichnung: "N26",
			kontoinhaber: kontoinhaber,
		}];
	};

	self.umsaetze = function() {
		function packZweck(list) {
			return list.filter(function(x) {return x}).join("\n");
		}

		scraper.httpGet("transactions", BASE_URL + "api/smrt/transactions", headers);
		var transactions = JSON.parse(scraper.getText());
		println("transactions", JSON.stringify(transactions, null, 4));
		var umsaetze = transactions.map(function(t) {
			return {
				gebucht: !t.pending,
				abgerechnet: true,
				valuta: scraper.reformatDate(new Date(t.createdTS)),
				datum: scraper.reformatDate(new Date(t.userAccepted || t.confirmed)),
				zweck: packZweck([t.referenceText, t.referenceToOriginalOperation]) || packZweck([t.merchantName, t.merchantCity]),
				betrag: t.amount,
				waehrung: t.currencyCode,
				eName: t.partnerName,
				eIban: t.partnerIban,
				eBic: t.partnerBic,
			};
		});
		return {
			umsaetze: umsaetze,
			endSaldo: {betrag: account.bankBalance, waehrung: "EUR", datum: scraper.reformatDate(new Date())},
		};
	};
})(window);
